var Defaults = xdc.useModule('xdc.runtime.Defaults');
var Diags = xdc.useModule('xdc.runtime.Diags');
var Error = xdc.useModule('xdc.runtime.Error');
var Log = xdc.useModule('xdc.runtime.Log');
var Main = xdc.useModule('xdc.runtime.Main');
var Memory = xdc.useModule('xdc.runtime.Memory')
var System = xdc.useModule('xdc.runtime.System');
var Text = xdc.useModule('xdc.runtime.Text');
//var LoggerBuf = xdc.useModule('xdc.runtime.LoggerBuf');
//var SysMin = xdc.useModule('xdc.runtime.SysMin');
var LoggerBuf = xdc.useModule('ti.sysbios.smp.LoggerBuf');
var SysMin = xdc.useModule('ti.sysbios.smp.SysMin');
xdc.useModule('xdc.runtime.Timestamp');

var BIOS        = xdc.useModule('ti.sysbios.BIOS');
BIOS.smpEnabled = true;
Posix = xdc.useModule('ti.sysbios.posix.Settings');
Posix.supportsMutexPriority = true;
var Hwi = xdc.useModule('ti.sysbios.hal.Hwi');
var HeapMem = xdc.useModule('ti.sysbios.heaps.HeapMem');
var CpIntc = xdc.useModule('ti.sysbios.family.arm.a15.tci66xx.CpIntc');

/* 
 * Program.argSize sets the size of the .args section. 
 * The examples don't use command line args so argSize is set to 0.
 */
Program.argSize = 0x0;

/*
 * Uncomment this line to globally disable Asserts.
 * All modules inherit the default from the 'Defaults' module.  You
 * can override these defaults on a per-module basis using Module.common$. 
 * Disabling Asserts will save code space and improve runtime performance.
Defaults.common$.diags_ASSERT = Diags.ALWAYS_OFF;
 */

/*
 * Uncomment this line to keep module names from being loaded on the target.
 * The module name strings are placed in the .const section. Setting this
 * parameter to false will save space in the .const section.  Error and
 * Assert messages will contain an "unknown module" prefix instead
 * of the actual module name.
Defaults.common$.namedModule = false;
 */

/*
 * Minimize exit handler array in System.  The System module includes
 * an array of functions that are registered with System_atexit() to be
 * called by System_exit().
 */
System.maxAtexitHandlers = 4;       

/* 
 * Uncomment this line to disable the Error print function.  
 * We lose error information when this is disabled since the errors are
 * not printed.  Disabling the raiseHook will save some code space if
 * your app is not using System_printf() since the Error_print() function
 * calls System_printf().
Error.raiseHook = null;
 */

/* 
 * Uncomment this line to keep Error, Assert, and Log strings from being
 * loaded on the target.  These strings are placed in the .const section.
 * Setting this parameter to false will save space in the .const section.
 * Error, Assert and Log message will print raw ids and args instead of
 * a formatted message.
Text.isLoaded = false;
 */

/*
 * Uncomment this line to disable the output of characters by SysMin
 * when the program exits.  SysMin writes characters to a circular buffer.
 * This buffer can be viewed using the SysMin Output view in ROV.
SysMin.flushAtExit = false;
 */

/*
 * The BIOS module will create the default heap for the system.
 * Specify the size of this default heap.
 */
BIOS.heapSize = 0xc0000;

/*
 * Build a custom SYS/BIOS library from sources.
 */
BIOS.libType = BIOS.LibType_Custom;

/* System stack size (used by ISRs and Swis) */
Program.stack = 0x20000;

/* Circular buffer size for System_printf() */
SysMin.bufSize = 0x400;

/* 
 * Create and install logger for the whole system
 */
var loggerBufParams = new LoggerBuf.Params();
loggerBufParams.numEntries = 32;
var logger0 = LoggerBuf.create(loggerBufParams);
Defaults.common$.logger = logger0;
Main.common$.diags_INFO = Diags.ALWAYS_ON;

System.SupportProxy = SysMin;
var SemiHost = xdc.useModule('ti.sysbios.rts.gnu.SemiHostSupport');

//var Core = xdc.useModule('ti.sysbios.family.arm.a15.Core');
var Core = xdc.useModule('ti.sysbios.family.arm.a15.smp.Core');
Core.useSkernelCmd = false; /* Set to false if running in CCS and using gel files to wake-up secondary cores */
Core.numCores = 4;

var Timestamp = xdc.useModule('xdc.runtime.Timestamp');
Timestamp.SupportProxy = xdc.useModule('ti.sysbios.timers.timer64.TimestampProvider');

//var Cache = xdc.useModule('ti.sysbios.family.arm.a15.Cache');
var Cache = xdc.useModule('ti.sysbios.family.arm.a15.smp.Cache');
var Mmu = xdc.useModule('ti.sysbios.family.arm.a15.Mmu');

// Enable the cache
Cache.enableCache = true;

// Enable the MMU (Required for L1/L2 data caching)
Mmu.enableMMU = true;

// descriptor attribute structure
var peripheralAttrs = new Mmu.DescriptorAttrs();

Mmu.initDescAttrsMeta(peripheralAttrs);

peripheralAttrs.type = Mmu.DescriptorType_BLOCK;  // BLOCK descriptor
peripheralAttrs.noExecute = true;                 // not executable
peripheralAttrs.accPerm = 0;                      // read/write at PL1
peripheralAttrs.attrIndx = 1;                     // MAIR0 Byte1 describes
                                                      // memory attributes for
                                                      // each BLOCK MMU entry

// Define the base address of the 2 MB page
// the peripheral resides in.
var peripheralBaseAddrs = [ 
  { base: 0x02530C00, size: 0x00000400 },  // UART 0 regs
  { base: 0x02531000, size: 0x00000400 },  // UART 1 regs
  { base: 0x21800000, size: 0x00004000 },  // pcie regs
  { base: 0x50000000, size: 0x10000000 },  // pcie data
  { base: 0x02320000, size: 0x00004000 },  // pcie phy
  { base: 0x0bc00000, size: 0x00010000 },  // msmc
  { base: 0x02700000, size: 0x000D0000 },  // edma  
  { base: 0x02350000, size: 0x00001000 }   // psc
];

// Configure the corresponding MMU page descriptor accordingly
for (var i =0; i < peripheralBaseAddrs.length; i++)
{
  for (var j = 0; j < peripheralBaseAddrs[i].size; j += 0x200000)
  {
      var addr = peripheralBaseAddrs[i].base + j;
      Mmu.setSecondLevelDescMeta(addr, addr, peripheralAttrs);
  }
}

// Reconfigure DDR to use coherent address
Mmu.initDescAttrsMeta(peripheralAttrs);

peripheralAttrs.type = Mmu.DescriptorType_BLOCK;
peripheralAttrs.shareable = 2;            // outer-shareable (3=inner, 0=none)
peripheralAttrs.accPerm = 1;              // read/write at any privelege level
peripheralAttrs.attrIndx = 2;             // normal cacheable (0=no cache, 1=strict order)
for (var vaddr = 0x80000000, paddr = 0x800000000; vaddr < 0x100000000; vaddr += 0x200000, paddr+= 0x200000)
{
      Mmu.setSecondLevelDescMeta(vaddr, paddr, peripheralAttrs);
}
// Add MSMC as coherent
for (var addr = 0x0c000000; addr < 0x0c600000; addr += 0x200000)
{
      Mmu.setSecondLevelDescMeta(addr, addr, peripheralAttrs);
}

/*
 * Program.sectMap[".text"]    = "MSMCSRAM";
 * Program.sectMap[".rodata"]  = "MSMCSRAM";
 * Program.sectMap[".data"]    = "MSMCSRAM";
 * Program.sectMap[".heap"]    = "MSMCSRAM";
 * Program.sectMap[".bss"]     = "MSMCSRAM";
 * Program.sectMap[".stack"]   = "MSMCSRAM";
 */

/* ================ Driver configuration ================ */

var socType = "k2h";

/*use CSL package*/
var Csl = xdc.useModule('ti.csl.Settings');
Csl.deviceType = socType;

/* Load the osal package -- required by board & interrupt example */
var osType = "tirtos"
var Osal = xdc.loadPackage('ti.osal');
Osal.Settings.osType = osType;
Osal.Settings.socType = socType;

/* Load the I2C package  - required by board */
var I2c = xdc.loadPackage('ti.drv.i2c');
I2c.Settings.socType = socType;

/* Load the uart package -- required by board */
var Uart = xdc.loadPackage('ti.drv.uart');
Uart.Settings.socType = socType;

/* Load the gpio package */
var Gpio = xdc.loadPackage('ti.drv.gpio');
Gpio.Settings.socType = socType;

/* Load the Board package and set the board name */
var Board = xdc.loadPackage('ti.board');
Board.Settings.boardName = "evmK2H";
